from django.db import models

class CreateTimeBaseObject(models.Model):
    created = models.DateTimeField(auto_now_add=True)
    modified = models.DateTimeField(auto_now=True)
    active = models.BooleanField(default=True)

    class Meta:
        abstract = True


class Release(CreateTimeBaseObject):
    name = models.CharField(max_length=255)


class Build(CreateTimeBaseObject):
    name = models.CharField(max_length=255)
    release = models.ForeignKey(Release, related_name='builds')
    description = models.TextField()
    status = models.CharField(max_length=16)

    def bvt_1(self):
        return self.stages.get(
            name='bvt_1')

    def bvt_2(self):
        return self.stages.get(
            name='bvt_2')

    def publish(self):
        return self.stages.get(
            name='publish')

    def build(self):
        return self.stages.get(
            name='build')

class Stage(CreateTimeBaseObject):
    name = models.CharField(max_length=255)
    build = models.ForeignKey(Build, related_name='stages')
    url = models.CharField(max_length=255, default='',
                           null=True, blank=True)
    value = models.CharField(max_length=255)
