from django.shortcuts import HttpResponse, render_to_response
from django.views.decorators.csrf import csrf_exempt

from sheet.models import Build, Release, Stage

from security.decorators import token_auth

import json

def index(request):
    releases = Release.objects.all()

    return render_to_response(
        'sheet/index.html',
        {
            'releases': releases,
        },
    )

@csrf_exempt
@token_auth
def add_stage(request, release, build):
    if request.method == 'POST':
        r, r_c = Release.objects.get_or_create(
            name=release)
        b, b_c = Build.objects.get_or_create(
            name=build, release=r)
        s, s_c = Stage.objects.get_or_create(
            name=request.POST.get('name'),
            build=b
        )

        s.url = request.POST.get('url')
        s.value = request.POST.get('value')
        s.save()

        if request.POST.get('description'):
            b.description = request.POST.get('description')
            b.save()

        stages = Stage.objects.filter(build=b)

        i = 0
        for stage in stages:
            if stage.value == 'fail':
                i+=1

        if i == 3 or i == 2:
            b.status = 'danger'
            b.save()
        elif i == 1:
            b.status = 'warning'
            b.save()
        elif i == 0:
            b.status = 'success'
            b.save()

        return HttpResponse(
            content=json.dumps({
                'status': 'ok',
            }),
            content_type='application/json'
        )
    else:
        return HttpResponse(
            content=json.dumps({
                'status': 'error',
                'message': 'request method should be POST',
            }),
            content_type='application/json',
            status='400',
        )
